'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parser = parser;
exports.compiler = compiler;
exports.transformer = transformer;

var _babelCore = require('babel-core');

var _babylon = require('babylon');

function parser(code, asset) {
  return (0, _babylon.parse)(code, asset.parserOptions);
}

function compiler(code, asset) {
  return transformer(code, asset).code;
}

function transformer(code, asset) {
  var id = asset.id;

  try {
    return (0, _babelCore.transform)(code, asset.transformerOptions);
  } catch (error) {
    return {
      ast: {},
      code: 'console.log(\'Error while compiling ' + id + '\', \'' + error.message + '\')',
      map: ''
    };
  }
}

function attemptRequire(moduleId) {
  try {
    return require(moduleId);
  } catch (error) {}
}