'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TransformerOptions = exports.ParserOptions = exports.Script = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _bluebird = require('bluebird');

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

var _asset = require('./asset');

var _asset2 = _interopRequireDefault(_asset);

var _docblock = require('../utils/docblock');

var _docblock2 = _interopRequireDefault(_docblock);

var _babel = require('./parsers/babel');

var _indexer = require('./script/indexer');

var _indexer2 = _interopRequireDefault(_indexer);

var _util = require('../util');

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _result = require('lodash/result');

var _result2 = _interopRequireDefault(_result);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EXTENSIONS = ['js', 'jsx', 'cjsx', 'coffee', 'es6'];
var GLOB = '**/*.{' + EXTENSIONS.join(',') + '}';

// can parse, index, transform js with babel

var Script = exports.Script = (function (_Asset) {
  (0, _inherits3.default)(Script, _Asset);

  function Script(uri) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
    (0, _classCallCheck3.default)(this, Script);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Script).call(this, uri, options));

    _util.hidden.property(_this, 'indexes', {});

    _this.transformer = function () {
      return (0, _babel.transformer)(_this.raw, _this);
    };

    _this.parser = function () {
      return (0, _babel.parser)(_this.raw, _this);
    };
    _this.indexer = function () {
      return (0, _indexer2.default)(_this.parsed, _this);
    };

    (0, _util.lazy)(_this, 'compiled', function () {
      return (0, _babel.compiler)(_this.raw, _this);
    });
    return _this;
  }

  (0, _createClass3.default)(Script, [{
    key: 'getData',
    value: function getData() {
      if (!this.raw || this.raw.length === 0) {
        this.runImporter('disk', { asset: this, sync: true });
      }

      return this.frontmatter || {};
    }
  }, {
    key: 'evalWithHelpers',
    value: function evalWithHelpers() {
      var helpers = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

      var project = this.project;
      var script = this;

      helpers = (0, _util.defaults)(helpers, {
        project: project,
        script: script,
        skypager: _index2.default
      });

      var fn = (0, _util.noConflict)((0, _bluebird.coroutine)(_regenerator2.default.mark(function _callee() {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                try {
                  eval(script.compiled);
                } catch (error) {
                  project.error('error in evaluating script', error);
                }

              case 1:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      })), helpers);

      fn();
    }
  }, {
    key: 'generateId',
    value: function generateId() {
      var base = '' + this.paths.relative.replace(this.extension, '');

      if (base.match(/\/index$/)) {
        base = base.replace(/\/index$/, '');
      }

      return base;
    }
  }, {
    key: 'parserOptions',
    get: function get() {
      return ParserOptions;
    }
  }, {
    key: 'transformerOptions',
    get: function get() {
      return TransformerOptions;
    }
  }, {
    key: 'exports',
    get: function get() {
      return (0, _get3.default)(this.modulesMetadata, 'exports.exported') || [];
    }
  }, {
    key: 'imports',
    get: function get() {
      return ((0, _get3.default)(this.modulesMetadata, 'imports') || []).map(function (i) {
        return i.source;
      });
    }
  }, {
    key: 'isReactComponent',
    get: function get() {
      if (this.defaultExportType === 'ClassDeclaration') {
        var superClass = (0, _result2.default)(this, 'defaultExportNode.declaration.superClass.name');

        if (superClass && superClass.match(/Component$/)) {
          return true;
        }
      }
    }
  }, {
    key: 'exportedClassNames',
    get: function get() {
      if (this.indexed) {
        var exports = this.indexes._exportNodes;

        return exports.filter(function (node) {
          return (0, _get3.default)(node, 'declaration.type') === 'ClassDeclaration';
        }).filter(function (node) {
          return (0, _get3.default)(node, 'declaration.id.type') === 'Identifier';
        }).map(function (node) {
          return (0, _get3.default)(node, 'declaration.id.name');
        });
      }
    }
  }, {
    key: 'importsLocalModules',
    get: function get() {
      if (this.indexed) {
        return this.importNodes.filter(function (n) {
          return n.source && n.source.value.match(/^\./);
        }).map(function (n) {
          return n.source.value;
        });
      }
    }
  }, {
    key: 'importsModuleNames',
    get: function get() {
      if (this.indexed) {
        return this.importNodes.map(function (n) {
          return n.source && n.source.value;
        });
      }
    }
  }, {
    key: 'importNodes',
    get: function get() {
      if (this.indexed) {
        return this.indexes._importNodes;
      }
    }
  }, {
    key: 'exportNodes',
    get: function get() {
      if (this.indexed) {
        return this.indexes._exportNodes;
      }
    }
  }, {
    key: 'defaultExportNode',
    get: function get() {
      if (this.indexed) {
        return this.exportNodes.find(function (d) {
          return d.type === 'ExportNamedDeclaration';
        });
      }
    }
  }, {
    key: 'defaultExportName',
    get: function get() {
      return (0, _result2.default)(this, 'defaultExportNode.declaration.id.name');
    }
  }, {
    key: 'defaultExportType',
    get: function get() {
      return (0, _result2.default)(this, 'defaultExportNode.declaration.type');
    }
  }, {
    key: 'modulesMetadata',
    get: function get() {
      return (0, _get3.default)(this.transformed, 'metadata.modules');
    }

    /**
     * @alias modulesMetadata
     */

  }, {
    key: 'moduleMetadata',
    get: function get() {
      return this.modulesMetadata;
    }
  }, {
    key: 'programBody',
    get: function get() {
      return (0, _get3.default)(this.parsed, 'program.body');
    }
  }, {
    key: 'frontmatter',
    get: function get() {
      try {
        return _docblock2.default.parse(this.raw);
      } catch (error) {
        return {};
      }
    }
  }]);
  return Script;
})(_asset2.default);

Script.EXTENSIONS = EXTENSIONS;
Script.GLOB = GLOB;
exports.default = Script;
var ParserOptions = exports.ParserOptions = {
  sourceType: 'module',
  plugins: ['jsx', 'asyncFunctions', 'classConstructorCall', 'doExpressions', 'trailingFunctionCommas', 'objectRestSpread', 'decorators', 'classProperties', 'exportExtensions', 'asyncGenerators', 'functionBind', 'functionSent']
};

var TransformerOptions = exports.TransformerOptions = {
  presets: [global.$skypager && global.$skypager.babelPresetSkypager || 'babel-preset-skypager']
};